167. Two Sum II — Input Array Is Sorted

Palistha
3 min readSep 15, 2022

--

Two Sum Solution

167. Two Sum II — Input Array Is Sorted
Medium

Given a 1-indexed array of integers numbers that is already sorted in non-decreasing order, find two numbers such that they add up to a specific target number. Let these two numbers be numbers[index1] and numbers[index2] where 1 <= index1 < index2 <= numbers.length.

Return the indices of the two numbers, index1 and index2, added by one as an integer array [index1, index2] of length 2.

The tests are generated such that there is exactly one solution. You may not use the same element twice.

Your solution must use only constant extra space.

Example 1:Input: numbers = [2,7,11,15], target = 9Output: [1,2]Explanation: The sum of 2 and 7 is 9. Therefore, index1 = 1, index2 = 2. We return [1, 2].Example 2:Input: numbers = [2,3,4], target = 6Output: [1,3]Explanation: The sum of 2 and 4 is 6. Therefore index1 = 1, index2 = 3. We return [1, 3].Example 3:Input: numbers = [-1,0], target = -1Output: [1,2]Explanation: The sum of -1 and 0 is -1. Therefore index1 = 1, index2 = 2. We return [1, 2].

Constraints:

2 <= numbers.length <= 3 * 104-1000 <= numbers[i] <= 1000numbers is sorted in non-decreasing order.-1000 <= target <= 1000The tests are generated such that there is exactly one solution.

Brute Force Approach

We will check the sum of every two elements.

Time complexity = O(n²)

Optimized Approach

We will find the sum of right and left.

Leetcode Two Sum Optimized Solution

If sum > target, it means we must decrease the value of the sum. To decrease the value of the sum we can decrease the value of the numbers we are adding. As the left is already small, we will decrease the index right by 1 to get the smaller sum.

If sum < target, it means we must increase the values we are adding. right is a larger value, so we will just increase the index of left by 1 to get a larger sum.

Let's understand this with help of an example:

Array = 2, 4, 6, 8, 11, 14 target = 14

2 + 14 = 16 > target

left + right < target

left + right > target

left + right < target

left + right = target

Code:

Time complexity = O(n)

We can also solve the problem using HashMap. Comment the solution if you solved the problem using HashMap.

--

--

Palistha
Palistha

Written by Palistha

Learning and Sharing Everyday

No responses yet